
package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.util.AttributeSet;
import android.view.SurfaceHolder;
import android.view.SurfaceHolder.Callback;
import android.view.SurfaceView;
import android.view.View;

public class AnimationView extends SurfaceView {
    Callback c = new Callback() {

        @Override
        public void surfaceDestroyed(SurfaceHolder holder) {
            holder.removeCallback(c);
        }

        @Override
        public void surfaceCreated(final SurfaceHolder holder) {
            new Thread() {
                public void run() {
                    while (mDo) {
                        try {
                            Canvas canvas = holder.lockCanvas();
                            drawC(canvas);
                            holder.unlockCanvasAndPost(canvas);
                            Thread.sleep(20);
                        } catch (Exception e) {
                        }
                    }
                }
            }.start();
        }

        @Override
        public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {

        }
    };
    BaseDrawable mBaseDrawable;

    private void drawC(Canvas canvas) {
        if (canvas != null) {
            canvas.drawColor(Color.TRANSPARENT, android.graphics.PorterDuff.Mode.CLEAR);
            canvas.save();
            mBaseDrawable.draw(canvas);
            canvas.drawText(mText, mBaseDrawable.getBounds().width() / 2, mBaseDrawable.getBounds().height() * 6 / 7, mPaint);
            canvas.restore();
        }
    };
    String mText = "你好";
    private Paint mPaint;
    public void setTextTips(String tips) {
        mText = tips;
    }
    @Override
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
        super.onSizeChanged(w, h, oldw, oldh);
        mBaseDrawable.setBounds(0, 0, w, h);
    }

    public AnimationView(Context context) {
        super(context);
        init(context);
    }
    public AnimationView(Context context, AttributeSet attr) {
        super(context,attr);
        init(context);
    }
    private void init(Context context) {
        getHolder().addCallback(c);
        setZOrderOnTop(true);
        mBaseDrawable = new BaseDrawable(context, getResources());
        getHolder().setFormat(PixelFormat.TRANSLUCENT);
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStrokeWidth(6);
        mPaint.setTextSize(DisplayUtil2.dp2px(getContext(), 16));
        mPaint.setTextAlign(Paint.Align.CENTER);
        mPaint.setColor(Color.parseColor("#575757"));
    }

    public void showView1() {
        mBaseDrawable.showV1();
    }

    public void showView2() {
        mBaseDrawable.showV2();
    }
    
    public void showBigCircle() {
        mBaseDrawable.showBigCircle();
    }
    
    public void setScaleSize(float s) {
        mBaseDrawable.setScaleSize(s);
    }
    
    public void ping() {
        mBaseDrawable.ping();
    }

    public void startBreatheAnim() {
//        mBaseDrawable.startBreatheAnim();
    }
    
    public void stopBreatheAnim() {
        mBaseDrawable.stopBreatheAnim();
    }
    
    public void postScaleAnim() {
//        mBaseDrawable.postScaleAnim();
    }

    public void clean() {
        this.setVisibility(View.GONE);
        mDo = false;
    }
    boolean mDo = true;;
}
