package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.ScaleAnimation;
import android.view.animation.Transformation;

public class BigCircleDrawable extends BitmapDrawable{
    Context mContext;
    private Paint mPaint;
    
    public BigCircleDrawable(Context context,Resources res) {
        mContext = context;
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStrokeWidth(DisplayUtil2.dp2px(context, 1.0f));
        mPaint.setStyle(Paint.Style.STROKE);
        mPaint.setColor(Color.parseColor("#ffcb96"));
    }
    
    @Override
    protected void onBoundsChange(Rect bounds) {
        super.onBoundsChange(bounds);
    }
    
    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        if (mShow) {
            canvas.clipRect(getBounds());
            canvas.save();
            canvas.drawCircle(getBounds().width() / 2,getBounds().height() / 2,DisplayUtil2.dp2px(mContext, 124), mPaint);
            canvas.restore();
        }
    }
    boolean mShow = false;
    public void showBigCircle() {
        mShow = true;
    }
}
