package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.ScaleAnimation;
import android.view.animation.Transformation;

public class BreatheDrawable extends BitmapDrawable{
    boolean isCancle = true;
    private Drawable mBreatheDrawable;
    Context mContext;
    private AnimationSet mAnimationSet;
    
    public BreatheDrawable(Context context,Resources res) {
        mBreatheDrawable = new BreatheDrawable1(context, res);
        mContext = context;
    }
    public void startBreathe(){
        isCancle = false;
        mAnimationSet = new AnimationSet(mContext, null);
        
        ScaleAnimation mScaleAnimation = new ScaleAnimation(1f,1.1f ,1.0f,1.1f,ScaleAnimation.RELATIVE_TO_SELF,0.5f,ScaleAnimation.RELATIVE_TO_SELF,0.5f);
        mScaleAnimation.initialize(getBounds().width(), getBounds().height(), getBounds().width(), getBounds().height());
        mScaleAnimation.setInterpolator(new AccelerateInterpolator());
        mScaleAnimation.setDuration(600);
        mScaleAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mScaleAnimation);
        
        mScaleAnimation = new ScaleAnimation(1.0f,0.91f ,1.0f,0.91f,ScaleAnimation.RELATIVE_TO_SELF,0.5f,ScaleAnimation.RELATIVE_TO_SELF,0.5f);
        mScaleAnimation.initialize(getBounds().width(), getBounds().height(), getBounds().width(), getBounds().height());
        mScaleAnimation.setInterpolator(new DecelerateInterpolator());
        mScaleAnimation.setDuration(1000);
        mScaleAnimation.setStartOffset(600);
        mScaleAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mScaleAnimation);
        mAnimationSet.setRepeatMode(Animation.RESTART);
        mAnimationSet.startNow();
        mAnimationSet.setAnimationListener(new AnimationListener() {
            
            @Override
            public void onAnimationStart(Animation animation) {
                
            }
            
            @Override
            public void onAnimationRepeat(Animation animation) {
                
            }
            
            @Override
            public void onAnimationEnd(Animation animation) {
                if (isCancle) {
                    return;
                }
                startBreathe();
            }
        });
    }
    public void stopBreathe() {
        mAnimationSet.cancel();
        isCancle = true;
    }
    @Override
    protected void onBoundsChange(Rect bounds) {
        super.onBoundsChange(bounds);
        mBreatheDrawable.setBounds(bounds);
        startBreathe();
    }
    
    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        canvas.clipRect(getBounds());
        canvas.save();
        Transformation tf = new Transformation();
        if (mAnimationSet != null && !isCancle) {
            mAnimationSet.getTransformation(AnimationUtils.currentAnimationTimeMillis(), tf);
            Matrix matrix = tf.getMatrix();
            canvas.concat(matrix);
        }
        mBreatheDrawable.draw(canvas);
        canvas.restore();
    }
}
