
package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.view.animation.AnimationSet;

import com.lenovo.lasf_lite.R;

public class BreatheDrawable1 extends BitmapDrawable {
    private Drawable mMic;
    Context mContext;
    private AnimationSet mAnimationSet;
    private Paint mPaint;

    public BreatheDrawable1(Context context, Resources res) {
        mMic = (BitmapDrawable) res.getDrawable(R.drawable.lasf_lite_center_recording_mic);
        mContext = context;
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStyle(Paint.Style.FILL);
        mPaint.setColor(Color.parseColor("#f5f5f5"));
    }

    @Override
    protected void onBoundsChange(Rect bounds) {
        super.onBoundsChange(bounds);
        mMic.setBounds((bounds.width() - mMic.getIntrinsicWidth()) / 2,
                (bounds.height() - mMic.getIntrinsicHeight()) / 2,
                (bounds.width() + mMic.getIntrinsicWidth()) / 2,
                (bounds.height() + mMic.getIntrinsicHeight()) / 2);
    }

    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        canvas.clipRect(getBounds());
        canvas.drawCircle(mMic.getBounds().centerX(), mMic.getBounds().centerY(), DisplayUtil2.dp2px(mContext, 38), mPaint);
        mMic.draw(canvas);
    }
}
