package com.lenovo.lasf.speech.view;

import android.app.Service;
import android.content.Context;
import android.util.DisplayMetrics;
import android.view.WindowManager;

public class DisplayUtil2 {
	private static int densityDpi = -1;

	public static float px2dp(Context context, float px) {
		initDensity(context);
		float dips = (px * 160f) / densityDpi;
		return dips;
	}

	public static float dp2px(Context context, float dp) {
		initDensity(context);
		float pixs = dp * (densityDpi / 160f);
		return pixs;
	}

	public static int getDensityDpi(Context context) {
		initDensity(context);
		return densityDpi;
	}

	private static void initDensity(Context context) {
		if (-1 == densityDpi) {
			WindowManager wm = (WindowManager) context.getSystemService(Service.WINDOW_SERVICE);
			DisplayMetrics dm = new DisplayMetrics();
			wm.getDefaultDisplay().getMetrics(dm);
			densityDpi = dm.densityDpi;
		}
	}
}
