package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.util.AttributeSet;
import android.util.Log;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.ScaleAnimation;
import android.view.animation.Transformation;

public class MyScaleAnimation extends Animation{

    private ScaleAnimation animation1;
    private ScaleAnimation animation2;
    private ScaleAnimation animation3;
    Transformation mOutT = new Transformation();
    private long beginT;
    Integer[] mPerT = new Integer[]{300,200,200};
    public MyScaleAnimation(Context context, AttributeSet attr,Integer ...perT) {
        super(context, attr);
        if (perT != null && perT.length == 3) {
            mPerT = perT;
        }
        animation1 = new ScaleAnimation(0.01f, 0.3f, 0.01f, 0.3f,
                Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
        animation1.setDuration(mPerT[0]);// 设置动画持续时间
        animation1.setFillAfter(true);// 动画执行完后是否停留在执行完的状态
        
        animation2 = new ScaleAnimation(0.3f, 0.01f, 0.3f, 0.65f,
                Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
        animation2.setDuration(mPerT[1]);// 设置动画持续时间
        animation2.setFillAfter(true);// 动画执行完后是否停留在执行完的状态
        
        animation3 = new ScaleAnimation(0.01f, 1.001f, 0.65f, 1.001f,
                Animation.RELATIVE_TO_SELF, 0.5f, Animation.RELATIVE_TO_SELF, 0.5f);
        animation3.setDuration(mPerT[2]);// 设置动画持续时间
        animation3.setFillAfter(false);// 动画执行完后是否停留在执行完的状态
        long duration = 0;
        for (Integer per : mPerT) {
            duration += per;
        }
        setDuration(duration);
    }
    
    @Override
    protected void applyTransformation(float interpolatedTime, Transformation t) {
        
        if (AnimationUtils.currentAnimationTimeMillis() - beginT < mPerT[0]) {
            animation1.getTransformation(AnimationUtils.currentAnimationTimeMillis(), mOutT);
            Log.e("xxx", "11111"+mOutT.getMatrix().toString());
        }
        if (AnimationUtils.currentAnimationTimeMillis() - beginT > mPerT[0]
                && AnimationUtils.currentAnimationTimeMillis() - beginT < (mPerT[0] + mPerT[1])) {
            animation2.getTransformation(AnimationUtils.currentAnimationTimeMillis(), mOutT);
            Log.e("xxx", "22222"+mOutT.getMatrix().toString());
        }
        if (AnimationUtils.currentAnimationTimeMillis() - beginT > (mPerT[0] + mPerT[1])) {
            animation3.getTransformation(AnimationUtils.currentAnimationTimeMillis(), mOutT);
            Log.e("xxx", "33333"+mOutT.getMatrix().toString());
        }
        t.set(mOutT);
    }
    
    @Override
    public void start() {
        super.start();
        beginT = AnimationUtils.currentAnimationTimeMillis();
        animation1.start();
        animation2.start();
        animation3.start();
    }
    @Override
    public void startNow() {
        super.startNow();
        beginT = AnimationUtils.currentAnimationTimeMillis();
        animation1.start();
        animation2.start();
        animation3.start();
    }
    
    @Override
    public void initialize(int width, int height, int parentWidth, int parentHeight) {
        super.initialize(width, height, parentWidth, parentHeight);
        animation1.initialize(width, height, parentWidth, parentHeight);
        animation2.initialize(width, height, parentWidth, parentHeight);
        animation3.initialize(width, height, parentWidth, parentHeight);
    }
}
