
package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.ScaleAnimation;
import android.view.animation.Transformation;

public class PingDrawable extends BitmapDrawable {
    Context mContext;
    private AnimationSet mAnimationSet;
    private Paint mPaint;
    boolean isAnimEnd = true;
    public PingDrawable(Context context, Resources res) {
        mContext = context;
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStrokeWidth(DisplayUtil2.dp2px(context, 1.2f));
        mPaint.setStyle(Paint.Style.STROKE);
        mPaint.setColor(Color.parseColor("#ffcb96"));
        
    }

    public void ping() {
        if (!isAnimEnd) {
            return;
        }
        isAnimEnd = false;
        mAnimationSet = new AnimationSet(mContext, null);

        ScaleAnimation mScaleAnimation = new ScaleAnimation(1.0f, 2.6f, 1.0f, 2.6f,ScaleAnimation.RELATIVE_TO_SELF,0.5f,ScaleAnimation.RELATIVE_TO_SELF,0.5f);
        mScaleAnimation.initialize(getBounds().width(), getBounds().height(), getBounds().width(), getBounds().height());
        mScaleAnimation.setInterpolator(new AccelerateInterpolator());
        mScaleAnimation.setDuration(800);
        // mScaleAnimation.setRepeatCount(Animation.INFINITE);
        mScaleAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mScaleAnimation);
        AlphaAnimation mAlphaAnimation = new AlphaAnimation(1f, 0.2f);
        mAlphaAnimation.setDuration(800);
        // mAlphaAnimation.setRepeatCount(Animation.INFINITE);
        mAlphaAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mAlphaAnimation);
        mAnimationSet.startNow();
        mAnimationSet.setAnimationListener(new AnimationListener() {
            
            @Override
            public void onAnimationStart(Animation animation) {
                
            }
            
            @Override
            public void onAnimationRepeat(Animation animation) {
                
            }
            
            @Override
            public void onAnimationEnd(Animation animation) {
                isAnimEnd = true;
            }
        });
    }

    @Override
    protected void onBoundsChange(Rect bounds) {
        super.onBoundsChange(bounds);
        ping();
    }

    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        if (!isAnimEnd) {
            canvas.save();
            canvas.clipRect(getBounds());
            Transformation tf = new Transformation();
            if (mAnimationSet != null) {
                mAnimationSet.getTransformation(AnimationUtils.currentAnimationTimeMillis(), tf);
                Matrix matrix = tf.getMatrix();
                canvas.concat(matrix);
            }
            mPaint.setAlpha((int) (tf.getAlpha() * 255));
            canvas.drawCircle(getBounds().width() / 2,getBounds().height() / 2,DisplayUtil2.dp2px(mContext, 44), mPaint);
            canvas.restore();
        }
    }
}
