package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.ScaleAnimation;
import android.view.animation.Transformation;

public class ScaleAnimDrawable extends BitmapDrawable{
    boolean isAnimEnd = false;
    Context mContext;
    private AnimationSet mAnimationSet;
    private Paint mPaint;
    
    public ScaleAnimDrawable(Context context,Resources res) {
        mContext = context;
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStyle(Paint.Style.FILL);
        mPaint.setColor(Color.parseColor("#ffcb96"));
    }
    public void postScaleAnim(){
        isAnimEnd = false;
        mAnimationSet = new AnimationSet(mContext, null);
        
        ScaleAnimation mScaleAnimation = new ScaleAnimation(1f,1.8f ,1.0f,1.8f,ScaleAnimation.RELATIVE_TO_SELF,0.5f,ScaleAnimation.RELATIVE_TO_SELF,0.5f);
        mScaleAnimation.initialize(getBounds().width(), getBounds().height(), getBounds().width(), getBounds().height());
        mScaleAnimation.setInterpolator(new AccelerateInterpolator());
        mScaleAnimation.setDuration(300);
        mScaleAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mScaleAnimation);
        
        mScaleAnimation = new ScaleAnimation(1.0f,0.55f ,1.0f,0.55f,ScaleAnimation.RELATIVE_TO_SELF,0.5f,ScaleAnimation.RELATIVE_TO_SELF,0.5f);
        mScaleAnimation.initialize(getBounds().width(), getBounds().height(), getBounds().width(), getBounds().height());
        mScaleAnimation.setInterpolator(new DecelerateInterpolator());
        mScaleAnimation.setDuration(600);
        mScaleAnimation.setStartOffset(300);
        mScaleAnimation.setRepeatMode(Animation.RESTART);
        mAnimationSet.addAnimation(mScaleAnimation);
        mAnimationSet.setRepeatMode(Animation.RESTART);
        mAnimationSet.startNow();
        mAnimationSet.setAnimationListener(new AnimationListener() {
            
            @Override
            public void onAnimationStart(Animation animation) {
                
            }
            
            @Override
            public void onAnimationRepeat(Animation animation) {
                
            }
            
            @Override
            public void onAnimationEnd(Animation animation) {
                isAnimEnd = true;
            }
        });
    }
    @Override
    protected void onBoundsChange(Rect bounds) {
        super.onBoundsChange(bounds);
        postScaleAnim();
    }
    
    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        canvas.save();
        if (mAnimationSet != null && !isAnimEnd) {
            Transformation tf = new Transformation();
            canvas.clipRect(getBounds());
            mAnimationSet.getTransformation(AnimationUtils.currentAnimationTimeMillis(), tf);
            Matrix matrix = tf.getMatrix();
            canvas.concat(matrix);
            canvas.drawColor(Color.TRANSPARENT);
            canvas.drawCircle(getBounds().width() / 2, getBounds().height() / 2,
                    DisplayUtil2.dp2px(mContext, 44), mPaint);
        }
        canvas.restore();
    }
}
