package com.lenovo.lasf.speech.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.BitmapDrawable;

public class ScaleDrawable extends BitmapDrawable{
    private Context mContext;
    private Paint mPaint;
    public ScaleDrawable(Context context,Resources res) {
        mContext = context;
        mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setStyle(Paint.Style.FILL);
        mPaint.setColor(Color.parseColor("#ffcb96"));
    }
    // radius::  88dp / 2 -- 176dp /2
    // scale::   1 - 2
    float mScaleSize = 44;
    public void setScaleXY(float scale){
        mScaleSize =  scale * 44;
    }
    @Override
    public void draw(Canvas canvas) {
        super.draw(canvas);
        canvas.clipRect(getBounds());
        canvas.drawColor(Color.TRANSPARENT);
        canvas.drawCircle(getBounds().width() / 2, getBounds().height() / 2, DisplayUtil2.dp2px(mContext, mScaleSize), mPaint);
    }
    void reset() {
        mScaleSize = 44;
        invalidateSelf();
    }
}
